////////////////////////////////////////////////////////////////////////////////
///
///		Title		: Windowless adapter Header
///
///		Copyright (c) 2007, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "NPCommonUI.h"
#include "Common.h"
#include "RootContainer.h"

#define	DECLARE_MESSAGE_HANDLER_REF(_x_)	virtual LRESULT _x_(UINT uMsg, WPARAM& wParam, LPARAM& lParam, BOOL &bHandled)
#define	IMPLEMENT_MESSAGE_HANDLER_REF(ClassName, Function)	LRESULT ClassName::Function(UINT uMsg, WPARAM& wParam, LPARAM& lParam, BOOL &bHandled)

/**
* @ingroup 	UIFrame Lib	
* @brief 	
* @date		02/01/2007
* @author	telltale
* @remark	
*/
class NPCOMMONUI_API CAdapterWindow
{
public:
	CAdapterWindow(void);
	virtual ~CAdapterWindow(void);

	/**
	* @brief 	create base window
	* @param	hWndParent	parent window handle
	* @return	If the function succeeds, return the TRUE
	*/
	BOOL	Create(HWND hWndParent);
	/**
	* @brief 	set boundary
	* @param	nX, nY, nWidth, nHeight (boundary)
	* @return	none
	*/
	void	MoveWindow(int nX, int nY, int nWidth, int nHeight);
	/**
	* @brief 	draw rootcontainer
	* @param	hDC display handle
	* @return	none
	*/
	void	Draw(HDC hDC);
	/**
	* @brief	the function retrieves the root container
	* @return	the pointer of root container
	*/
	CRootContainer*	GetRootContainer() { return &m_rootContainer; }
	
BEGIN_MSG_MAP(CAdapterWindow)
	//MESSAGE_RANGE_HANDLER(WM_MOUSEFIRST, WM_MOUSELAST, OnMouseEvent);
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)

	CHAIN_MSG_MAP_MEMBER(m_rootContainer)

	MESSAGE_HANDLER(WM_MOUSELEAVE, OnMouseLeave)

END_MSG_MAP()

	//DECLARE_MESSAGE_HANDLER_REF(OnMouseEvent);
	DECLARE_MESSAGE_HANDLER(OnMouseMove);
	DECLARE_MESSAGE_HANDLER(OnMouseLeave);

private:
	CRootContainer	m_rootContainer;
	BOOL			m_bTracking;
};
